using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DirectStreamWav
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Button btnListen;
		private System.Windows.Forms.Button btnStop;
		private System.Windows.Forms.Button btnDisconnect;
		private System.Windows.Forms.Button btnConnect;
		private System.Windows.Forms.Timer timer1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.ComboBox cbRate;
		private System.Windows.Forms.ComboBox cbCodec;
		private System.Windows.Forms.Label label8;
        private System.Windows.Forms.Label label14;
		private System.Windows.Forms.TextBox tbHost;
		private System.Windows.Forms.TextBox tbClientPort;
		private System.Windows.Forms.ComboBox cbClientProto;
		private AxVCProX.AxvcproIpClientX ipClient;
        private AxVCProX.AxvcproWaveCodecDeviceX codec1;
		private AxVCProX.AxvcproWaveCodecDeviceX codec2;
		private AxVCProX.AxvcproIpServerX ipServer;
		private System.Windows.Forms.TextBox tbServerPort;
        private System.Windows.Forms.ComboBox cbServerProto;
        private TextBox tbRecordFile;
        private TextBox tbPlaybackFile;
        private AxVCProX.AxvcproWaveRiffX waveRiffWrite;
        private AxVCProX.AxvcproWaveResamplerX resampler;
        private AxVCProX.AxvcproWaveRiffX waveRiffRead;
        private CheckBox cbStereo;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.waveRiffWrite = new AxVCProX.AxvcproWaveRiffX();
            this.tbRecordFile = new System.Windows.Forms.TextBox();
            this.label11 = new System.Windows.Forms.Label();
            this.label10 = new System.Windows.Forms.Label();
            this.panel1 = new System.Windows.Forms.Panel();
            this.btnStop = new System.Windows.Forms.Button();
            this.btnListen = new System.Windows.Forms.Button();
            this.codec2 = new AxVCProX.AxvcproWaveCodecDeviceX();
            this.ipServer = new AxVCProX.AxvcproIpServerX();
            this.label3 = new System.Windows.Forms.Label();
            this.tbServerPort = new System.Windows.Forms.TextBox();
            this.cbServerProto = new System.Windows.Forms.ComboBox();
            this.label1 = new System.Windows.Forms.Label();
            this.label9 = new System.Windows.Forms.Label();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.resampler = new AxVCProX.AxvcproWaveResamplerX();
            this.waveRiffRead = new AxVCProX.AxvcproWaveRiffX();
            this.tbPlaybackFile = new System.Windows.Forms.TextBox();
            this.label14 = new System.Windows.Forms.Label();
            this.label13 = new System.Windows.Forms.Label();
            this.label12 = new System.Windows.Forms.Label();
            this.panel2 = new System.Windows.Forms.Panel();
            this.btnDisconnect = new System.Windows.Forms.Button();
            this.btnConnect = new System.Windows.Forms.Button();
            this.tbHost = new System.Windows.Forms.TextBox();
            this.label4 = new System.Windows.Forms.Label();
            this.tbClientPort = new System.Windows.Forms.TextBox();
            this.cbClientProto = new System.Windows.Forms.ComboBox();
            this.label6 = new System.Windows.Forms.Label();
            this.ipClient = new AxVCProX.AxvcproIpClientX();
            this.codec1 = new AxVCProX.AxvcproWaveCodecDeviceX();
            this.label7 = new System.Windows.Forms.Label();
            this.timer1 = new System.Windows.Forms.Timer(this.components);
            this.cbRate = new System.Windows.Forms.ComboBox();
            this.label2 = new System.Windows.Forms.Label();
            this.cbCodec = new System.Windows.Forms.ComboBox();
            this.label8 = new System.Windows.Forms.Label();
            this.cbStereo = new System.Windows.Forms.CheckBox();
            this.groupBox1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.waveRiffWrite)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.codec2)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.ipServer)).BeginInit();
            this.groupBox2.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.resampler)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.waveRiffRead)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.ipClient)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.codec1)).BeginInit();
            this.SuspendLayout();
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.waveRiffWrite);
            this.groupBox1.Controls.Add(this.tbRecordFile);
            this.groupBox1.Controls.Add(this.label11);
            this.groupBox1.Controls.Add(this.label10);
            this.groupBox1.Controls.Add(this.panel1);
            this.groupBox1.Controls.Add(this.btnStop);
            this.groupBox1.Controls.Add(this.btnListen);
            this.groupBox1.Controls.Add(this.codec2);
            this.groupBox1.Controls.Add(this.ipServer);
            this.groupBox1.Controls.Add(this.label3);
            this.groupBox1.Controls.Add(this.tbServerPort);
            this.groupBox1.Controls.Add(this.cbServerProto);
            this.groupBox1.Controls.Add(this.label1);
            this.groupBox1.Controls.Add(this.label9);
            this.groupBox1.Location = new System.Drawing.Point(8, 56);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(272, 256);
            this.groupBox1.TabIndex = 0;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Listen to device";
            // 
            // waveRiffWrite
            // 
            this.waveRiffWrite.Enabled = true;
            this.waveRiffWrite.Location = new System.Drawing.Point(191, 127);
            this.waveRiffWrite.Name = "waveRiffWrite";
            this.waveRiffWrite.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("waveRiffWrite.OcxState")));
            this.waveRiffWrite.Size = new System.Drawing.Size(64, 32);
            this.waveRiffWrite.TabIndex = 21;
            // 
            // tbRecordFile
            // 
            this.tbRecordFile.Location = new System.Drawing.Point(8, 42);
            this.tbRecordFile.Name = "tbRecordFile";
            this.tbRecordFile.Size = new System.Drawing.Size(168, 20);
            this.tbRecordFile.TabIndex = 20;
            this.tbRecordFile.Text = "c:\\temp\\record.wav";
            // 
            // label11
            // 
            this.label11.AutoSize = true;
            this.label11.Location = new System.Drawing.Point(8, 232);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(41, 13);
            this.label11.TabIndex = 17;
            this.label11.Text = "label11";
            // 
            // label10
            // 
            this.label10.AutoSize = true;
            this.label10.Location = new System.Drawing.Point(8, 216);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(41, 13);
            this.label10.TabIndex = 16;
            this.label10.Text = "label10";
            // 
            // panel1
            // 
            this.panel1.BackColor = System.Drawing.Color.Black;
            this.panel1.Location = new System.Drawing.Point(8, 208);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(248, 1);
            this.panel1.TabIndex = 15;
            // 
            // btnStop
            // 
            this.btnStop.Location = new System.Drawing.Point(96, 168);
            this.btnStop.Name = "btnStop";
            this.btnStop.Size = new System.Drawing.Size(72, 24);
            this.btnStop.TabIndex = 12;
            this.btnStop.Text = "Stop";
            this.btnStop.Click += new System.EventHandler(this.btnStop_Click);
            // 
            // btnListen
            // 
            this.btnListen.Location = new System.Drawing.Point(8, 168);
            this.btnListen.Name = "btnListen";
            this.btnListen.Size = new System.Drawing.Size(72, 24);
            this.btnListen.TabIndex = 11;
            this.btnListen.Text = "Listen";
            this.btnListen.Click += new System.EventHandler(this.btnListen_Click);
            // 
            // codec2
            // 
            this.codec2.Enabled = true;
            this.codec2.Location = new System.Drawing.Point(191, 84);
            this.codec2.Name = "codec2";
            this.codec2.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("codec2.OcxState")));
            this.codec2.Size = new System.Drawing.Size(64, 32);
            this.codec2.TabIndex = 9;
            // 
            // ipServer
            // 
            this.ipServer.Enabled = true;
            this.ipServer.Location = new System.Drawing.Point(191, 44);
            this.ipServer.Name = "ipServer";
            this.ipServer.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("ipServer.OcxState")));
            this.ipServer.Size = new System.Drawing.Size(56, 32);
            this.ipServer.TabIndex = 8;
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(96, 71);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(26, 13);
            this.label3.TabIndex = 5;
            this.label3.Text = "Port";
            // 
            // tbServerPort
            // 
            this.tbServerPort.Location = new System.Drawing.Point(96, 88);
            this.tbServerPort.Name = "tbServerPort";
            this.tbServerPort.Size = new System.Drawing.Size(80, 20);
            this.tbServerPort.TabIndex = 4;
            this.tbServerPort.Text = "2020";
            // 
            // cbServerProto
            // 
            this.cbServerProto.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cbServerProto.Items.AddRange(new object[] {
            "TCP",
            "UDP"});
            this.cbServerProto.Location = new System.Drawing.Point(8, 88);
            this.cbServerProto.Name = "cbServerProto";
            this.cbServerProto.Size = new System.Drawing.Size(80, 21);
            this.cbServerProto.TabIndex = 1;
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(8, 71);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(46, 13);
            this.label1.TabIndex = 0;
            this.label1.Text = "Protocol";
            // 
            // label9
            // 
            this.label9.AutoSize = true;
            this.label9.Location = new System.Drawing.Point(8, 23);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(68, 13);
            this.label9.TabIndex = 19;
            this.label9.Text = "File to record";
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.resampler);
            this.groupBox2.Controls.Add(this.waveRiffRead);
            this.groupBox2.Controls.Add(this.tbPlaybackFile);
            this.groupBox2.Controls.Add(this.label14);
            this.groupBox2.Controls.Add(this.label13);
            this.groupBox2.Controls.Add(this.label12);
            this.groupBox2.Controls.Add(this.panel2);
            this.groupBox2.Controls.Add(this.btnDisconnect);
            this.groupBox2.Controls.Add(this.btnConnect);
            this.groupBox2.Controls.Add(this.tbHost);
            this.groupBox2.Controls.Add(this.label4);
            this.groupBox2.Controls.Add(this.tbClientPort);
            this.groupBox2.Controls.Add(this.cbClientProto);
            this.groupBox2.Controls.Add(this.label6);
            this.groupBox2.Controls.Add(this.ipClient);
            this.groupBox2.Controls.Add(this.codec1);
            this.groupBox2.Controls.Add(this.label7);
            this.groupBox2.Location = new System.Drawing.Point(288, 56);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(272, 256);
            this.groupBox2.TabIndex = 1;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Stream to device";
            // 
            // resampler
            // 
            this.resampler.Enabled = true;
            this.resampler.Location = new System.Drawing.Point(189, 88);
            this.resampler.Name = "resampler";
            this.resampler.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("resampler.OcxState")));
            this.resampler.Size = new System.Drawing.Size(64, 32);
            this.resampler.TabIndex = 33;
            // 
            // waveRiffRead
            // 
            this.waveRiffRead.Enabled = true;
            this.waveRiffRead.Location = new System.Drawing.Point(189, 44);
            this.waveRiffRead.Name = "waveRiffRead";
            this.waveRiffRead.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("waveRiffRead.OcxState")));
            this.waveRiffRead.Size = new System.Drawing.Size(66, 34);
            this.waveRiffRead.TabIndex = 32;
            // 
            // tbPlaybackFile
            // 
            this.tbPlaybackFile.Location = new System.Drawing.Point(8, 45);
            this.tbPlaybackFile.Name = "tbPlaybackFile";
            this.tbPlaybackFile.Size = new System.Drawing.Size(168, 20);
            this.tbPlaybackFile.TabIndex = 31;
            this.tbPlaybackFile.Text = "c:\\temp\\playback.wav";
            // 
            // label14
            // 
            this.label14.AutoSize = true;
            this.label14.Location = new System.Drawing.Point(8, 23);
            this.label14.Name = "label14";
            this.label14.Size = new System.Drawing.Size(81, 13);
            this.label14.TabIndex = 30;
            this.label14.Text = "File to playback";
            // 
            // label13
            // 
            this.label13.AutoSize = true;
            this.label13.Location = new System.Drawing.Point(8, 232);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(41, 13);
            this.label13.TabIndex = 28;
            this.label13.Text = "label13";
            // 
            // label12
            // 
            this.label12.AutoSize = true;
            this.label12.Location = new System.Drawing.Point(8, 216);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(41, 13);
            this.label12.TabIndex = 27;
            this.label12.Text = "label12";
            // 
            // panel2
            // 
            this.panel2.BackColor = System.Drawing.Color.Black;
            this.panel2.Location = new System.Drawing.Point(8, 208);
            this.panel2.Name = "panel2";
            this.panel2.Size = new System.Drawing.Size(248, 1);
            this.panel2.TabIndex = 26;
            // 
            // btnDisconnect
            // 
            this.btnDisconnect.Location = new System.Drawing.Point(96, 168);
            this.btnDisconnect.Name = "btnDisconnect";
            this.btnDisconnect.Size = new System.Drawing.Size(75, 24);
            this.btnDisconnect.TabIndex = 25;
            this.btnDisconnect.Text = "Stop";
            this.btnDisconnect.Click += new System.EventHandler(this.btnDisconnect_Click);
            // 
            // btnConnect
            // 
            this.btnConnect.Location = new System.Drawing.Point(8, 168);
            this.btnConnect.Name = "btnConnect";
            this.btnConnect.Size = new System.Drawing.Size(75, 24);
            this.btnConnect.TabIndex = 24;
            this.btnConnect.Text = "Talk";
            this.btnConnect.Click += new System.EventHandler(this.btnConnect_Click);
            // 
            // tbHost
            // 
            this.tbHost.Location = new System.Drawing.Point(96, 136);
            this.tbHost.Name = "tbHost";
            this.tbHost.Size = new System.Drawing.Size(80, 20);
            this.tbHost.TabIndex = 22;
            this.tbHost.Text = "192.168.1.1";
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Location = new System.Drawing.Point(96, 71);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(26, 13);
            this.label4.TabIndex = 21;
            this.label4.Text = "Port";
            // 
            // tbClientPort
            // 
            this.tbClientPort.Location = new System.Drawing.Point(96, 88);
            this.tbClientPort.Name = "tbClientPort";
            this.tbClientPort.Size = new System.Drawing.Size(80, 20);
            this.tbClientPort.TabIndex = 20;
            this.tbClientPort.Text = "3030";
            // 
            // cbClientProto
            // 
            this.cbClientProto.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cbClientProto.Items.AddRange(new object[] {
            "TCP",
            "UDP"});
            this.cbClientProto.Location = new System.Drawing.Point(8, 88);
            this.cbClientProto.Name = "cbClientProto";
            this.cbClientProto.Size = new System.Drawing.Size(80, 21);
            this.cbClientProto.TabIndex = 17;
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(8, 71);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(46, 13);
            this.label6.TabIndex = 16;
            this.label6.Text = "Protocol";
            // 
            // ipClient
            // 
            this.ipClient.Enabled = true;
            this.ipClient.Location = new System.Drawing.Point(189, 168);
            this.ipClient.Name = "ipClient";
            this.ipClient.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("ipClient.OcxState")));
            this.ipClient.Size = new System.Drawing.Size(56, 32);
            this.ipClient.TabIndex = 15;
            // 
            // codec1
            // 
            this.codec1.Enabled = true;
            this.codec1.Location = new System.Drawing.Point(189, 127);
            this.codec1.Name = "codec1";
            this.codec1.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("codec1.OcxState")));
            this.codec1.Size = new System.Drawing.Size(64, 32);
            this.codec1.TabIndex = 12;
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(96, 120);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(94, 13);
            this.label7.TabIndex = 23;
            this.label7.Text = "Device IP-address";
            // 
            // timer1
            // 
            this.timer1.Enabled = true;
            this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
            // 
            // cbRate
            // 
            this.cbRate.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cbRate.Items.AddRange(new object[] {
            "8000",
            "11025",
            "16000",
            "22050",
            "24000",
            "32000",
            "44100"});
            this.cbRate.Location = new System.Drawing.Point(96, 24);
            this.cbRate.Name = "cbRate";
            this.cbRate.Size = new System.Drawing.Size(80, 21);
            this.cbRate.TabIndex = 7;
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(96, 8);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(71, 13);
            this.label2.TabIndex = 6;
            this.label2.Text = "Sampling rate";
            // 
            // cbCodec
            // 
            this.cbCodec.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cbCodec.Items.AddRange(new object[] {
            "1 (PCM)",
            "2 (ADPCM)",
            "6 (a-Law)",
            "7 (u-Law)",
            "49 (GSM)",
            "85 (MP3)"});
            this.cbCodec.Location = new System.Drawing.Point(8, 24);
            this.cbCodec.Name = "cbCodec";
            this.cbCodec.Size = new System.Drawing.Size(80, 21);
            this.cbCodec.TabIndex = 9;
            this.cbCodec.SelectedValueChanged += new System.EventHandler(this.cbCodec_SelectedValueChanged);
            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.Location = new System.Drawing.Point(8, 8);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(38, 13);
            this.label8.TabIndex = 8;
            this.label8.Text = "Codec";
            // 
            // cbStereo
            // 
            this.cbStereo.AutoSize = true;
            this.cbStereo.Location = new System.Drawing.Point(198, 26);
            this.cbStereo.Name = "cbStereo";
            this.cbStereo.Size = new System.Drawing.Size(57, 17);
            this.cbStereo.TabIndex = 11;
            this.cbStereo.Text = "Stereo";
            this.cbStereo.UseVisualStyleBackColor = true;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(570, 319);
            this.Controls.Add(this.cbStereo);
            this.Controls.Add(this.cbCodec);
            this.Controls.Add(this.label8);
            this.Controls.Add(this.groupBox2);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.cbRate);
            this.Controls.Add(this.label2);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.MaximizeBox = false;
            this.Name = "Form1";
            this.Text = "DirectStreamWav ::  (C) Lake of Soft";
            this.Closed += new System.EventHandler(this.Form1_Closed);
            this.Load += new System.EventHandler(this.Form1_Load);
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.waveRiffWrite)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.codec2)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.ipServer)).EndInit();
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.resampler)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.waveRiffRead)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.ipClient)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.codec1)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void SetLink(VCProX.IvcproProvider provider, VCProX.IvcproConsumer consumer)
		{
			provider.AddConsumer(consumer);
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
	        cbRate.SelectedIndex = 0;
			cbCodec.SelectedIndex = 2;
			cbServerProto.SelectedIndex = 0;
			cbClientProto.SelectedIndex = 1;

			ipServer.StreamingMode = VCProX.unaStreamingMode.unapt_RAW;
			ipClient.StreamingMode = VCProX.unaStreamingMode.unapt_RAW;

			ipServer.IsFormatProvider = false;
		
			SetLink((VCProX.IvcproProvider)waveRiffRead.GetOcx(), (VCProX.IvcproConsumer)resampler.GetOcx());
            SetLink((VCProX.IvcproProvider)resampler.GetOcx(), (VCProX.IvcproConsumer)codec1.GetOcx());
            SetLink((VCProX.IvcproProvider)codec1.GetOcx(), (VCProX.IvcproConsumer)ipClient.GetOcx());
		    
			SetLink((VCProX.IvcproProvider)ipServer.GetOcx(), (VCProX.IvcproConsumer)codec2.GetOcx());
			SetLink((VCProX.IvcproProvider)codec2.GetOcx(), (VCProX.IvcproConsumer)waveRiffWrite.GetOcx());
		}

		private int CodecTag()
		{
			switch (cbCodec.SelectedIndex)
			{
				case 0: return 1; // PCM
				case 1: return 2; // ADPCM
				case 2: return 6; // a-Law
				case 3: return 7; // u-Law
				case 4: return 49; // GSM
				case 5: return 85; // MP3

				default: return 1; // PCM
			}
		}

		private void Form1_Closed(object sender, System.EventArgs e)
		{
			timer1.Enabled = false;
		    StopClient();
		    StopServer();
		}

		private void StartServer()
		{
			ipServer.Proto = (VCProX.unaProtoType)cbServerProto.SelectedIndex;
			ipServer.Port = tbServerPort.Text;

            codec2.PcmSamplesPerSec = Convert.ToInt32(cbRate.Text);
            codec2.FormatTag = CodecTag();
            if (cbStereo.Checked) codec2.PcmNumChannels = 2; else codec2.PcmNumChannels = 1;

            waveRiffWrite.FileName = tbRecordFile.Text;

            ipServer.Active = true;
		}

		private void StopServer()
		{
			ipServer.Active = false;
		}

		private void StartClient()
		{
            waveRiffRead.FileName = tbPlaybackFile.Text;

			codec1.PcmSamplesPerSec = Convert.ToInt32(cbRate.Text);
			codec1.FormatTag = CodecTag();
            if (cbStereo.Checked) codec1.PcmNumChannels = 2; else codec1.PcmNumChannels = 1;

            resampler.DstBitsPerSample = codec1.PcmBitsPerSample;
            resampler.DstNumChannels = codec1.PcmNumChannels;
            resampler.DstSamplesPerSec = codec1.PcmSamplesPerSec;

			ipClient.Proto = (VCProX.unaProtoType)cbClientProto.SelectedIndex;
			ipClient.Port = tbClientPort.Text;
			ipClient.Host = tbHost.Text;

			waveRiffRead.Active = true;
		}

		private void StopClient()
		{
			waveRiffRead.Active = false;
		}

		private void timer1_Tick(object sender, System.EventArgs e)
		{
			btnStop.Enabled = ipServer.Active;
			btnListen.Enabled = !btnStop.Enabled;
			btnDisconnect.Enabled = ipClient.Active;
			btnConnect.Enabled = !btnDisconnect.Enabled;

			label10.Text = String.Format("bytes received: {0}", ipServer.BytesReceived);
			label11.Text = String.Format("bytes sent: {0}", ipServer.BytesSent);
			label12.Text = String.Format("bytes received: {0}", ipClient.BytesReceived);
			label13.Text = String.Format("bytes sent: {0}", ipClient.BytesSent);
		}

		private void btnListen_Click(object sender, System.EventArgs e)
		{
			StartServer();
		}

		private void btnStop_Click(object sender, System.EventArgs e)
		{
			StopServer();
		}

		private void btnConnect_Click(object sender, System.EventArgs e)
		{
			StartClient();
		}

		private void btnDisconnect_Click(object sender, System.EventArgs e)
		{
			StopClient();
		}

        private void cbCodec_SelectedValueChanged(object sender, EventArgs e)
        {
            if (CodecTag() == 6 || CodecTag() == 7 || CodecTag() == 49)
            {
                cbStereo.Checked = false;
                cbStereo.Enabled = false;
            }
            else cbStereo.Enabled = true;
        }
	}
}
